// Vertor.cpp : Implementation of CVertor

#include "stdafx.h"
#include "Vertor.h"


// CVertor

STDMETHODIMP CVertor::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IVertor
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CVertor::addVector(floatVector v1, floatVector v2, floatVector* out)
{
	if (v1.size!=v2.size){
		return Error("Zle wymiary",IID_IVertor,E_FAIL);
	}
	(*out).size=v1.size;
	(*out).data=(float*)CoTaskMemAlloc((*out).size*sizeof(float));
	for (UINT i=0;i<(*out).size;++i){
		(*out).data[i]=v1.data[i]+v2.data[i];
	}
	return S_OK;
}

STDMETHODIMP CVertor::addString(LPSTR s1, LPSTR s2, LPSTR* out)
{
	// TODO: Add your implementation code here
	(*out)=(LPSTR)CoTaskMemAlloc(strlen(s1)+strlen(s2)+1);
	strcpy(*out,s1);
//	strcpy((*out)+strlen(s1),s2);
	strcat(*out,s2);
	return S_OK;
}
