// Vertor.h : Declaration of the CVertor

#pragma once
#include "resource.h"       // main symbols

#include "Vector_srv_i.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CVertor

class ATL_NO_VTABLE CVertor :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CVertor, &CLSID_Vertor>,
	public ISupportErrorInfo,
	public IVertor
{
public:
	CVertor()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_VERTOR)


BEGIN_COM_MAP(CVertor)
	COM_INTERFACE_ENTRY(IVertor)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:

	STDMETHOD(addVector)(floatVector v1, floatVector v2, floatVector* out);
	STDMETHOD(addString)(LPSTR s1, LPSTR s2, LPSTR* out);
};

OBJECT_ENTRY_AUTO(__uuidof(Vertor), CVertor)
